Package org.apache.qpid.proton.codec

# Class DecoderImpl

java.lang.Object
org.apache.qpid.proton.codec.DecoderImpl

All Implemented Interfaces:
  `ByteBufferDecoder`, `Decoder`

public class DecoderImpl extends Object implements ByteBufferDecoder

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.apache.qpid.proton.codec.Decoder

`Decoder.ListProcessor<T>`

## Constructor Summary

Constructors
Constructor
Description
`DecoderImpl()`

## Method Summary

Modifier and Type
Method
Description
`ReadableBuffer`
`getBuffer()`
`ByteBuffer`
`getByteBuffer()`
`int`
`getByteBufferRemaining()`
`TypeConstructor<?>`
`peekConstructor()`
`Object[]`
`readArray()`
`<T> T[]`
`readArray(Class<T> clazz)`
`Binary`
`readBinary()`
`Binary`
`readBinary(Binary defaultValue)`
`Boolean`
`readBoolean()`
`boolean`
`readBoolean(boolean defaultVal)`
`Boolean`
`readBoolean(Boolean defaultVal)`
`boolean[]`
`readBooleanArray()`
`Byte`
`readByte()`
`byte`
`readByte(byte defaultVal)`
`Byte`
`readByte(Byte defaultVal)`
`byte[]`
`readByteArray()`
`byte[]`
`readByteMultiple()`
`Character`
`readCharacter()`
`char`
`readCharacter(char defaultVal)`
`Character`
`readCharacter(Character defaultVal)`
`char[]`
`readCharacterArray()`
`char[]`
`readCharacterMultiple()`
`TypeConstructor`
`readConstructor()`
`TypeConstructor`
`readConstructor(boolean excludeFastPathConstructors)`
`Decimal128`
`readDecimal128()`
`Decimal128`
`readDecimal128(Decimal128 defaultValue)`
`Decimal32`
`readDecimal32()`
`Decimal32`
`readDecimal32(Decimal32 defaultValue)`
`Decimal64`
`readDecimal64()`
`Decimal64`
`readDecimal64(Decimal64 defaultValue)`
`Double`
`readDouble()`
`double`
`readDouble(double defaultVal)`
`Double`
`readDouble(Double defaultVal)`
`double[]`
`readDoubleArray()`
`double[]`
`readDoubleMultiple()`
`Float`
`readFloat()`
`float`
`readFloat(float defaultVal)`
`Float`
`readFloat(Float defaultVal)`
`float[]`
`readFloatArray()`
`float[]`
`readFloatMultiple()`
`Integer`
`readInteger()`
`int`
`readInteger(int defaultVal)`
`Integer`
`readInteger(Integer defaultVal)`
`int[]`
`readIntegerArray()`
`int[]`
`readIntegerMultiple()`
`List`
`readList()`
`<T> void`
`readList(Decoder.ListProcessor<T> processor)`
`Long`
`readLong()`
`long`
`readLong(long defaultVal)`
`Long`
`readLong(Long defaultVal)`
`long[]`
`readLongArray()`
`long[]`
`readLongMultiple()`
`Map`
`readMap()`
`Object[]`
`readMultiple()`
`<T> T[]`
`readMultiple(Class<T> clazz)`
`Object`
`readObject()`
`Object`
`readObject(Object defaultValue)`
`Short`
`readShort()`
`short`
`readShort(short defaultVal)`
`Short`
`readShort(Short defaultVal)`
`short[]`
`readShortArray()`
`short[]`
`readShortMultiple()`
`String`
`readString()`
`String`
`readString(String defaultValue)`
`Symbol`
`readSymbol()`
`Symbol`
`readSymbol(Symbol defaultValue)`
`Date`
`readTimestamp()`
`Date`
`readTimestamp(Date defaultValue)`
`UnsignedByte`
`readUnsignedByte()`
`UnsignedByte`
`readUnsignedByte(UnsignedByte defaultVal)`
`UnsignedInteger`
`readUnsignedInteger()`
`UnsignedInteger`
`readUnsignedInteger(UnsignedInteger defaultVal)`
`UnsignedLong`
`readUnsignedLong()`
`UnsignedLong`
`readUnsignedLong(UnsignedLong defaultVal)`
`UnsignedShort`
`readUnsignedShort()`
`UnsignedShort`
`readUnsignedShort(UnsignedShort defaultVal)`
`UUID`
`readUUID()`
`UUID`
`readUUID(UUID defaultVal)`
`void`
`register(Object descriptor, DescribedTypeConstructor dtc)`
`void`
`register(Object descriptor, FastPathDescribedTypeConstructor<?> btc)`
`void`
`setBuffer(ReadableBuffer buffer)`
`void`
`setByteBuffer(ByteBuffer buffer)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### DecoderImpl

public DecoderImpl()

## Method Details

### peekConstructor

public TypeConstructor<?> peekConstructor()

### readConstructor

public TypeConstructor readConstructor()

### readConstructor

public TypeConstructor readConstructor(boolean excludeFastPathConstructors)

### register

public void register(Object descriptor, FastPathDescribedTypeConstructor<?> btc)

Specified by:
  `register` in interface `Decoder`

### register

public void register(Object descriptor, DescribedTypeConstructor dtc)

Specified by:
  `register` in interface `Decoder`

### readBoolean

public Boolean readBoolean()

Specified by:
  `readBoolean` in interface `Decoder`

### readBoolean

public Boolean readBoolean(Boolean defaultVal)

Specified by:
  `readBoolean` in interface `Decoder`

### readBoolean

public boolean readBoolean(boolean defaultVal)

Specified by:
  `readBoolean` in interface `Decoder`

### readByte

public Byte readByte()

Specified by:
  `readByte` in interface `Decoder`

### readByte

public Byte readByte(Byte defaultVal)

Specified by:
  `readByte` in interface `Decoder`

### readByte

public byte readByte(byte defaultVal)

Specified by:
  `readByte` in interface `Decoder`

### readShort

public Short readShort()

Specified by:
  `readShort` in interface `Decoder`

### readShort

public Short readShort(Short defaultVal)

Specified by:
  `readShort` in interface `Decoder`

### readShort

public short readShort(short defaultVal)

Specified by:
  `readShort` in interface `Decoder`

### readInteger

public Integer readInteger()

Specified by:
  `readInteger` in interface `Decoder`

### readInteger

public Integer readInteger(Integer defaultVal)

Specified by:
  `readInteger` in interface `Decoder`

### readInteger

public int readInteger(int defaultVal)

Specified by:
  `readInteger` in interface `Decoder`

### readLong

public Long readLong()

Specified by:
  `readLong` in interface `Decoder`

### readLong

public Long readLong(Long defaultVal)

Specified by:
  `readLong` in interface `Decoder`

### readLong

public long readLong(long defaultVal)

Specified by:
  `readLong` in interface `Decoder`

### readUnsignedByte

public UnsignedByte readUnsignedByte()

Specified by:
  `readUnsignedByte` in interface `Decoder`

### readUnsignedByte

public UnsignedByte readUnsignedByte(UnsignedByte defaultVal)

Specified by:
  `readUnsignedByte` in interface `Decoder`

### readUnsignedShort

public UnsignedShort readUnsignedShort()

Specified by:
  `readUnsignedShort` in interface `Decoder`

### readUnsignedShort

public UnsignedShort readUnsignedShort(UnsignedShort defaultVal)

Specified by:
  `readUnsignedShort` in interface `Decoder`

### readUnsignedInteger

public UnsignedInteger readUnsignedInteger()

Specified by:
  `readUnsignedInteger` in interface `Decoder`

### readUnsignedInteger

public UnsignedInteger readUnsignedInteger(UnsignedInteger defaultVal)

Specified by:
  `readUnsignedInteger` in interface `Decoder`

### readUnsignedLong

public UnsignedLong readUnsignedLong()

Specified by:
  `readUnsignedLong` in interface `Decoder`

### readUnsignedLong

public UnsignedLong readUnsignedLong(UnsignedLong defaultVal)

Specified by:
  `readUnsignedLong` in interface `Decoder`

### readCharacter

public Character readCharacter()

Specified by:
  `readCharacter` in interface `Decoder`

### readCharacter

public Character readCharacter(Character defaultVal)

Specified by:
  `readCharacter` in interface `Decoder`

### readCharacter

public char readCharacter(char defaultVal)

Specified by:
  `readCharacter` in interface `Decoder`

### readFloat

public Float readFloat()

Specified by:
  `readFloat` in interface `Decoder`

### readFloat

public Float readFloat(Float defaultVal)

Specified by:
  `readFloat` in interface `Decoder`

### readFloat

public float readFloat(float defaultVal)

Specified by:
  `readFloat` in interface `Decoder`

### readDouble

public Double readDouble()

Specified by:
  `readDouble` in interface `Decoder`

### readDouble

public Double readDouble(Double defaultVal)

Specified by:
  `readDouble` in interface `Decoder`

### readDouble

public double readDouble(double defaultVal)

Specified by:
  `readDouble` in interface `Decoder`

### readUUID

public UUID readUUID()

Specified by:
  `readUUID` in interface `Decoder`

### readUUID

public UUID readUUID(UUID defaultVal)

Specified by:
  `readUUID` in interface `Decoder`

### readDecimal32

public Decimal32 readDecimal32()

Specified by:
  `readDecimal32` in interface `Decoder`

### readDecimal32

public Decimal32 readDecimal32(Decimal32 defaultValue)

Specified by:
  `readDecimal32` in interface `Decoder`

### readDecimal64

public Decimal64 readDecimal64()

Specified by:
  `readDecimal64` in interface `Decoder`

### readDecimal64

public Decimal64 readDecimal64(Decimal64 defaultValue)

Specified by:
  `readDecimal64` in interface `Decoder`

### readDecimal128

public Decimal128 readDecimal128()

Specified by:
  `readDecimal128` in interface `Decoder`

### readDecimal128

public Decimal128 readDecimal128(Decimal128 defaultValue)

Specified by:
  `readDecimal128` in interface `Decoder`

### readTimestamp

public Date readTimestamp()

Specified by:
  `readTimestamp` in interface `Decoder`

### readTimestamp

public Date readTimestamp(Date defaultValue)

Specified by:
  `readTimestamp` in interface `Decoder`

### readBinary

public Binary readBinary()

Specified by:
  `readBinary` in interface `Decoder`

### readBinary

public Binary readBinary(Binary defaultValue)

Specified by:
  `readBinary` in interface `Decoder`

### readSymbol

public Symbol readSymbol()

Specified by:
  `readSymbol` in interface `Decoder`

### readSymbol

public Symbol readSymbol(Symbol defaultValue)

Specified by:
  `readSymbol` in interface `Decoder`

### readString

public String readString()

Specified by:
  `readString` in interface `Decoder`

### readString

public String readString(String defaultValue)

Specified by:
  `readString` in interface `Decoder`

### readList

public List readList()

Specified by:
  `readList` in interface `Decoder`

### readList

public <T> void readList(Decoder.ListProcessor<T> processor)

Specified by:
  `readList` in interface `Decoder`

### readMap

public Map readMap()

Specified by:
  `readMap` in interface `Decoder`

### readArray

public <T> T[] readArray(Class<T> clazz)

Specified by:
  `readArray` in interface `Decoder`

### readArray

public Object[] readArray()

Specified by:
  `readArray` in interface `Decoder`

### readBooleanArray

public boolean[] readBooleanArray()

Specified by:
  `readBooleanArray` in interface `Decoder`

### readByteArray

public byte[] readByteArray()

Specified by:
  `readByteArray` in interface `Decoder`

### readShortArray

public short[] readShortArray()

Specified by:
  `readShortArray` in interface `Decoder`

### readIntegerArray

public int[] readIntegerArray()

Specified by:
  `readIntegerArray` in interface `Decoder`

### readLongArray

public long[] readLongArray()

Specified by:
  `readLongArray` in interface `Decoder`

### readFloatArray

public float[] readFloatArray()

Specified by:
  `readFloatArray` in interface `Decoder`

### readDoubleArray

public double[] readDoubleArray()

Specified by:
  `readDoubleArray` in interface `Decoder`

### readCharacterArray

public char[] readCharacterArray()

Specified by:
  `readCharacterArray` in interface `Decoder`

### readMultiple

public <T> T[] readMultiple(Class<T> clazz)

Specified by:
  `readMultiple` in interface `Decoder`

### readMultiple

public Object[] readMultiple()

Specified by:
  `readMultiple` in interface `Decoder`

### readByteMultiple

public byte[] readByteMultiple()

Specified by:
  `readByteMultiple` in interface `Decoder`

### readShortMultiple

public short[] readShortMultiple()

Specified by:
  `readShortMultiple` in interface `Decoder`

### readIntegerMultiple

public int[] readIntegerMultiple()

Specified by:
  `readIntegerMultiple` in interface `Decoder`

### readLongMultiple

public long[] readLongMultiple()

Specified by:
  `readLongMultiple` in interface `Decoder`

### readFloatMultiple

public float[] readFloatMultiple()

Specified by:
  `readFloatMultiple` in interface `Decoder`

### readDoubleMultiple

public double[] readDoubleMultiple()

Specified by:
  `readDoubleMultiple` in interface `Decoder`

### readCharacterMultiple

public char[] readCharacterMultiple()

Specified by:
  `readCharacterMultiple` in interface `Decoder`

### readObject

public Object readObject()

Specified by:
  `readObject` in interface `Decoder`

### readObject

public Object readObject(Object defaultValue)

Specified by:
  `readObject` in interface `Decoder`

### setByteBuffer

public void setByteBuffer(ByteBuffer buffer)

Specified by:
  `setByteBuffer` in interface `ByteBufferDecoder`

### getByteBuffer

public ByteBuffer getByteBuffer()

### setBuffer

public void setBuffer(ReadableBuffer buffer)

### getBuffer

public ReadableBuffer getBuffer()

### getByteBufferRemaining

public int getByteBufferRemaining()

Specified by:
  `getByteBufferRemaining` in interface `ByteBufferDecoder`